﻿
class Profesor implements ISubject
{
	
	private var arrayObservers		: Array;
	
	function Profesor( )
	{
		init( );
	}
	
	private function debug( arg: String ) : Void
	{
		trace("Profesor: ->"+arg);
	}
	
	private function init( ): Void
	{
		debug( "init" );
		this.arrayObservers = new Array(); 
	}
	
	public function addObserver( obs: IObserver ): Boolean
	{
		// Aquí comprobamos que el observer que estamos intentando añadir, no está ya en el array de 
		// observers. En caso que esté, no lo añadiremos y retornaremos false.  En caso que no esté, 
		// lo añadimos y retornamos true.
		debug("registrando");
		this.arrayObservers.push( obs );
		return true;
	}
	
	public function removeObserver( obs: IObserver ) : Boolean 
	{
		// comprobamos que el observer a eliminar está en el array. Que no está, retornamos false, que está
		// lo eliminamos y retornamos true
		var longObservers: Number = this.arrayObservers.length;
		for ( var k: Number = 0; k< longObservers; k++ )
		{
			var tmpObserver: IObserver = this.arrayObservers[ k ];
			if( tmpObserver == obs )
			{
					this.arrayObservers.splice( k, 1 );
					break;
			}
				
		}
		return true;
	}
	
	public function notifyObserver( info: Object ): Void
	{
		var longObservers: Number = this.arrayObservers.length;
		for ( var k: Number = 0; k<longObservers; k++ )
		{
			var tmpObserver: IObserver = this.arrayObservers[ k ];
			tmpObserver.update( info );
		}
	}
	
	public function requestInfo( arg: String ): Void
	{
		var info: Object = new Object ();
		info.cancion=arg;
		notifyObserver( info ) ;
	}
	
}











